/*====================================================================

 - Flash Apps Hider for TI89/TI92+/V200 -
 by Olivier Armand (ExtendeD)
 <ola.e-ml@wanadoo.fr>

 current version : a0.1
 Initial Date : 01/01/2003
 Last Update  : 01/12/2003
 See ReadMe.txt for details.

 Your are having a look at this source code because your are curious
 about the functioning of Flash Apps Hider. Of course I like your
 curiosity, that's why FlapHider is an open-source project.

 The only thing I ask you in return of this source code is not to
 infringe this simple license :

 YOU ARE NOT ALLOWED TO REUSE OR MODIFY ANY PART OF THIS SOURCE CODE
 WHITHOUT MY AUTHORIZATION.

 VOUS N'ETES PAS AUTORISE A REUTILISER OU MODIFIER CES SOURCES SANS
 MON AUTORISATION.
 
 If you have any questions about this source code, e-mail me.

===================================================================

 Compile with the GCC Switches :
 -fno-function-cse -mregparm=6 -fomit-frame-pointer

===================================================================*/


//#define USE_TI89
//#define USE_TI92PLUS
//#define USE_V200

#define MIN_AMS 205
#define NO_AMS_CHECK
#define USE_FLINE_ROM_CALLS
#define NO_EXIT_SUPPORT
#define SET_FILE_IN_USE_BIT   // we are using dialog boxes

#include <tigcclib.h>

#if (defined(__TIGCC__VERSION) && (__TIGCC_VERSION__ < 94))
#error You need TIGCC v0.94 or higher to build this project
#endif
// (http://tigcc.ticalc.org)

#include "sub_routines.h"
#include "functions.h"


void _main (void)
{
	unsigned short AppsNum;
	HANDLE AppsDataList_handle, ResultsHandle;
	unsigned long OldMemState;
	
	HeapCompress ();
	OldMemState = HeapAvail ();

	AppsDataList_handle = PrepareAppsData (&AppsNum);
	if (!AppsNum)   // test AppsNum first !
	fatal ("No Flash Apps installed.");
	if (!(AppsDataList_handle))
		fatal ("Not enough memory.");
	
	{
		BOOL EnterPressed;
		
		if (!(ResultsHandle = ShowMenu (AppsNum, AppsDataList_handle, &EnterPressed))) {
				HeapFree (AppsDataList_handle);
				fatal ("Not enough memory.");
		}
		if (!EnterPressed) {
			HeapFree (ResultsHandle);
			HeapFree (AppsDataList_handle);
			fatal ("No Flash Apps were hidden/unhidden.");
		}
	}   // ShowMenu block

	{	
		BOOL SomethingDone, CouldHide;
		
		CouldHide = HideApps (ResultsHandle, AppsDataList_handle, AppsNum, &SomethingDone);
		HeapFree (ResultsHandle);
		HeapFree (AppsDataList_handle);
		if (!SomethingDone) {
			ST_helpMsg ("No Flash Apps were hidden/unhidden.");
			return;
		}
		ShowMemState (OldMemState);
		if (!CouldHide)
		ST_helpMsg ("Some Apps could not be hidden/unhidden.");

	}   // HideApps block
	
} // _main()


//--------------------------------------------------------------------------

